////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RadioJet
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

// GetUrlFile = get a file from internet

#include "stdafx.h"
#include "GlobalTools.h"
#include "GetUrlFile.h" 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

GetUrlFile::GetUrlFile()
{
	session = new MyInternetSession(NULL, 1, PRE_CONFIG_INTERNET_ACCESS);
	pFile=NULL;
	pServer=NULL;	
	writefile=NULL;
}

GetUrlFile::~GetUrlFile()
{
	if(session)
		{
		CloseURL();
		session->Close();
		delete session; 
		}
}

int GetUrlFile::GetFile(char *pURL, char *pfilename)
{
	int ret=-1;
	int repeat=-1;
	int loop=16;

	char	filename[512];
	char	pszURL[512];
	strcpy(pszURL,pURL);
	strcpy(filename,pfilename);

	while(repeat++ < REPEATATION && ret) 
		{
		ret=XGetFile(pszURL,filename);
		if(ret==URL_NOT_FOUND) break;
		if(ret==URL_CAPACITY_PROBLEME)
			{
			Sleep(5000);
			loop--;
			if(loop>0) repeat--;
			}
		}

	return ret;
}

int GetUrlFile::XGetFile(char *pszURL, char *filename)
{
	int ret=NULL;
	char buf[512];

	if(!session) 
		{
		ErrorMessages("GET URL FILE SESSION CREATE ERROR");
		return URL_SESION_CREATE_ERR;
		}

	lastclock=(double)clock()-1.0;
	if(ret=OpenURL(pszURL, filename,NULL)) goto end;
	while(nRead) ReadFile();
	if(m_filelen && m_seek!=m_filelen) ret=URL_READ_ERR;
	sprintf(buf,"%.1f kB",(double)m_seek/((double)clock()-lastclock));

end:
	CloseURL();
	return ret;
}


int GetUrlFile::OpenURL(char *pszURL, char *filename, char *filetxt)
{
	char	buf[512];
	char	tmp[512];
	int		iflag;
	int		last_error=0;
	static	CString ServerName;


	AfxParseURL(pszURL,dwServiceType, strServerName, strObject, nPort);
	if(last_error==URL_PEX_ERR) 
		{
		if(!(ServerName,strServerName)) return last_error;
		}
	iflag=INTERNET_FLAG_EXISTING_CONNECT | INTERNET_FLAG_TRANSFER_BINARY  
		| INTERNET_FLAG_RESYNCHRONIZE	   |INTERNET_FLAG_NO_AUTO_REDIRECT
		| INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE;

	if(dwServiceType==AFX_INET_SERVICE_HTTPS)
		{
		iflag|=INTERNET_FLAG_SECURE;
		}

	ServerName=strServerName;

	myProg->SetPos(1);

	m_filelen=0; m_filetime=0;
	CloseURL();
	try
		{
		ConnectOn();

		pServer = session->GetHttpConnection(strServerName, nPort);
		if(!pServer) {last_error=URL_PEX_ERR; CloseURL(); return URL_PEX_ERR;}
		pFile	= pServer->OpenRequest(CHttpConnection::HTTP_VERB_GET,strObject, NULL, 1, NULL, NULL,iflag);
		pFile->AddRequestHeaders("Accept: */*\r\nUser-Agent: GET HTTP\r\n",HTTP_ADDREQ_FLAG_REPLACE);
		myProg->SetPos(5);
		pFile->SendRequest();
		myProg->SetPos(10);
		pFile->QueryInfoStatusCode(dwRet);
		myProg->SetPos(15);

		if (dwRet>=200 && dwRet<400) // == HTTP_STATUS_OK)
			{
			m_filelen=GetURLFileLen();
			myProg->SetPos(20);
			if(!m_filelen) m_filetime=::time(NULL);
			else m_filetime=GetURLFileTime();
			pFile->QueryInfo(HTTP_QUERY_RAW_HEADERS_CRLF, strNewLocation);
			myProg->SetPos(25);
			}
		else 
			{
			CloseURL();
			if(dwRet==URL_CAPACITY_PROBLEME) 
				{
				last_error=URL_CAPACITY_PROBLEME;
				return URL_CAPACITY_PROBLEME;
				}
			if(dwRet==URL_NOT_FOUND) 
				{
				CloseURL();
				sprintf(tmp,"URL NOT FOUND\nURL: %s",pszURL);
				ErrorMessages(tmp);
				last_error=URL_NOT_FOUND;
				return URL_NOT_FOUND;
				}
			last_error=URL_NOT_OK;
			return URL_NOT_OK;
			}
		}
	catch (CInternetException* pEx)
		{
		// catch errors from WinINet
		TCHAR szErr[512];
		pEx->GetErrorMessage(szErr, 512);
		sprintf(tmp,"GET URL FILE OPEN ERROR\nURL:%s\n%s",pszURL,szErr);
		ErrorMessages(tmp);
		CloseURL();
		pEx->Delete();
		last_error=URL_PEX_ERR;
		return URL_PEX_ERR;
		}


	strcpy(buf,filename);
	MakeDir(filename); 
	nRead=1023;
	m_seek=0;

	writefile=fopen(buf,"wb");
	if(!writefile) return URL_WROPEN_ERR;

	return NULL;
}


int GetUrlFile::GetURLFileLen()
{
	pFile->QueryInfo(HTTP_QUERY_CONTENT_LENGTH, strNewLocation);
	DWORD A=GetLastError();
	return(atoi(strNewLocation));
}

time_t GetUrlFile::GetURLFileTime()
{
	SYSTEMTIME			pSysTime={0};

	pFile->QueryInfo(HTTP_QUERY_LAST_MODIFIED|HTTP_QUERY_FLAG_SYSTEMTIME,&pSysTime,NULL);
	if(!pSysTime.wYear||!pSysTime.wMonth||!pSysTime.wDay)
		{
		::GetSystemTime(&pSysTime);
		}

	CTime tim(pSysTime); 
	return tim.GetTime();
}

void GetUrlFile::CloseURL()
{
	if (pFile != NULL)		
		{
		pFile->Close(); 
		delete pFile;
		pFile = NULL;
		}
	if (pServer != NULL)	
		{
		pServer->Close(); 
		delete 	pServer;
		pServer = NULL;
		ConnectOff();
		}
	if(writefile) 
		{
		fclose(writefile);
		writefile=NULL;
		}
}


int GetUrlFile::ReadFile()
{
	TCHAR szErr[512];

	if(nRead)
		{
		try
			{
			nRead = pFile->Read(m_readbuf, MAXFTPREAD);
			}
		catch (CInternetException* pEx)
			{
			// catch errors from WinINet
			pEx->GetErrorMessage(szErr, 512);
			sprintf(m_readbuf,"GET URL FILE READ ERROR: %s",szErr);
			ErrorMessages(m_readbuf);
			pEx->Delete();
			nRead=0;
			}
		}

	
	if(nRead>0) 
		{
		if(fwrite(m_readbuf,1,nRead,writefile)!=(size_t)nRead) goto end;						
		m_seek+=nRead;

		int pset=(int)(double)((100.0/(double)m_filelen)*(double)m_seek);
		myProg->SetPos(pset);
		}
	else
		{
end:
		nRead=0;	
		CloseURL();
		}
	
	return nRead;
}

int GetUrlFile::GetURL_LenTime(char *pURL, int *filelen, time_t *filetime)
{
	int ret=-1;
	int repeat=-1;
	int loop=16;


	char	pszURL[512];
	strcpy(pszURL,pURL);
	while(repeat++ < REPEATATION && ret) 
		{
		ret=XGetURL_LenTime(pszURL,filelen,filetime);
		if(ret==URL_NOT_FOUND) break;
		if(ret==URL_CAPACITY_PROBLEME)
			{
			Sleep(5000);
			loop--;
			if(loop>0) repeat--;
			}
		}
	return ret;
}

int GetUrlFile::XGetURL_LenTime(char *pszURL, int *filelen, time_t *filetime)
{
	char	buf[512];
	int		last_error=0,iflag;
	static	CString ServerName;


	*filelen=0;
	*filetime=0;

	AfxParseURL(pszURL,dwServiceType, strServerName, strObject, nPort);
	if(last_error==URL_PEX_ERR) 
		{
		if(!(ServerName,strServerName)) return last_error;
		}
	iflag=INTERNET_FLAG_EXISTING_CONNECT | INTERNET_FLAG_TRANSFER_BINARY  
		| INTERNET_FLAG_RESYNCHRONIZE	   |INTERNET_FLAG_NO_AUTO_REDIRECT
		| INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE;

	if(dwServiceType==AFX_INET_SERVICE_HTTPS)
		{
		iflag|=INTERNET_FLAG_SECURE;
		}
	ServerName=strServerName;

	CloseURL();
	try
		{
		ConnectOn();
		pServer = session->GetHttpConnection(strServerName,nPort);
		if(!pServer) {last_error=URL_PEX_ERR; CloseURL(); return URL_PEX_ERR;}
		pFile	= pServer->OpenRequest(CHttpConnection::HTTP_VERB_GET,
					strObject, NULL, 1,(LPCTSTR*)"*/*\0\0\0", NULL,iflag);
		if(!pFile) {last_error=URL_PEX_ERR; CloseURL(); return URL_PEX_ERR;}
		pFile->AddRequestHeaders("Accept: */*\r\nUser-Agent: GET HTTP\r\n",HTTP_ADDREQ_FLAG_REPLACE);
		pFile->SendRequest();
		*filelen=GetURLFileLen();
		*filetime=GetURLFileTime();
		pFile->QueryInfoStatusCode(dwRet);
		if (dwRet>=200 && dwRet<400) // == HTTP_STATUS_OK)
				{
				*filetime=GetURLFileTime();
				*filelen=GetURLFileLen();
				}
		else *filetime=*filelen=0;

		if(dwRet==URL_CAPACITY_PROBLEME) 
			{
			CloseURL();
			last_error=URL_CAPACITY_PROBLEME;
			return URL_CAPACITY_PROBLEME;
			}
		if(dwRet==URL_NOT_FOUND) 
			{
			CloseURL();
			last_error=URL_NOT_FOUND;
			return URL_NOT_FOUND;
			}
		if(!*filelen) 
			{
			CloseURL();
			last_error=URL_NOT_OK;
			return URL_NOT_OK;
			}
		}
	catch (CInternetException* pEx)
		{
		// catch errors from WinINet
		if(pszURL[0]!=0)
			{	
			TCHAR szErr[512];
			pEx->GetErrorMessage(szErr, 512);
			sprintf(buf,"GET URL FILE OPEN ERROR\nURL:%s\n%s",pszURL,szErr);
			ErrorMessages(buf);
			}
		pEx->Delete();
		CloseURL();
		last_error=URL_PEX_ERR;
		return URL_PEX_ERR;
		}

	CloseURL();
	return NULL;
}

