////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RadioJet
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////
#include "stdafx.h"
#include "resource.h"
#include <direct.h>
#include <sys/utime.h>
#include <mmsystem.h>
#include <io.h>

#include "FrqConverter.h"
#include "FrqConverterDlg.h"
#include "Defs.h"


//#include "OwnTestRoutines.cpp"

char				myDIR[256];
class CFrqConverterDlg *my_mainframe=NULL;	

///////////////////////////////////////////////////////////
////////////////////// get Tables, List and Strings ///////////////////
///////////////////////////////////////////////////////////

IsoList			myCountries,myLanguages; 
SortIndex		mySortedCountries,mySortedLanguages;
CStringArray	myProgramTypes, myRegionsList, DataAudioTypes, CodecTypes;
IsoBList		myADM,myANT,myBRC,myFMO,myTRG;
SortIndex		mySortedADM,mySortedANT,mySortedBRC,mySortedFMO,mySortedTRG;
CProgressCtrl	*myProg=NULL;
DWORD			timeout=60*CLOCKS_PER_SEC;
char			FrqConvDir[256];
FrqListData		FrqData;
HWND			QuitWin=0;

time_t  WINAPI GetLastWriteTime(char *filename)
{
	WIN32_FILE_ATTRIBUTE_DATA fattr;

	//return FALSE is the same as file not exist;
	if(!GetFileAttributesEx(filename, GetFileExInfoStandard, &fattr))  return FALSE;
	CTime	tim(fattr.ftLastWriteTime);
	return tim.GetTime(); 
}

//kill the last spaces
int WINAPI KillspaceSL(char *buf)
{
	for(int i=(int)strlen(buf)-1; i>=0 ; i--)
		{
		if(buf[i]!=' ' && buf[i]!=13 && buf[i]!=10 && buf[i]!=9 && buf[i]!='/')
			{
			buf[i+1]=0; 
			break;
			}
		}
	return strlen(buf);
}

//kill the last spaces
int WINAPI Killspace(char *buf)
{
	for(int i=(int)strlen(buf)-1; i>=0 ; i--)
		{
		if(buf[i]!=' ' && buf[i]!=13 && buf[i]!=10 && buf[i]!=9)
			{
			buf[i+1]=0; break;
			}
		}
	return strlen(buf);
}

int WINAPI KillDoubleSpace(char *buf)
{
	Killspace(buf);
	int x,i;

	for(x=0,i=0; i<(int)strlen(buf); i++)
		{
		if(buf[i]==' ' && buf[i+1]==' ') continue;
		buf[x++]=buf[i]; 
		}
	buf[x]=0;
	return strlen(buf);
}

int WINAPI KillBothDir(char *buf)
{
	Killspace(buf);
	int x,i;

	for(x=0,i=0; i<(int)strlen(buf); i++)
		{
		if(!x && buf[i]==' ') continue;
		buf[x++]=buf[i]; 
		}
	buf[x]=0;
	return strlen(buf);
}

typedef struct
				{
				int		Region_nr;
				int		lon;
				int		lat;
				char	RegionName1[32];
				char	RegionName2[32];
				int		LinePntr;
				int		LineSize[4];
				int		LinePosLon[4][32];
				int		LinePosLat[4][32];
				}WMORGN;

typedef struct	{
				COORDIANTE	p[64];
				int			count;
				int			region;
				}WMO_REGION_POINTS;

typedef CArray<WMO_REGION_POINTS,WMO_REGION_POINTS&> RegPoints;

typedef struct
	{
	UINT	population;		//4:population/500
	UINT	item:24;		//8:24:source position = unsorted;
	UINT	RegionNr:4;		//8:28:the number of the region
	UINT	type:4;			//8:32:0=city 1=prefix; 3=Country/Region
	UINT	height:16;		//12:16:height in meter
	UINT	country:10;		//12:26:ISO-Number = index of the country list
	UINT	DoubleFlags:2;	//12:28:this flag indicates that the name is twice
	UINT	WorkFlags:4;	//12:32:for intern sort routines and so one....	
	}CITY;


typedef struct
	{
	UINT	LocSetID;		// 4:a uniqu ID = (today&0xFFFF)<<16; + ?-count
	short	lon,lat;		// 8:location coordinates
	short	cx,cy;			//12:witdh, height
 	char	name[32];		//44:(excl. ':') name of the City, normal <32 chars --> if included a prefix, then the prefix is splitted by ':'
	union
		{
		char prefix[12];
		CITY city;
		};
	}LOCATION;

typedef	CArray<LOCATION,LOCATION&> Location;



WMORGN			WmoRegs[7]={0};
RegPoints		wmoRegions;
Location		myLocations;

void WINAPI LoadRegions() 
{
	FILE	*fi;
	char	buf[512];
	int		i,l,y,k;
	WMO_REGION_POINTS	wmoPoints;

	sprintf(buf,"%s\\Data\\WmoRegions.bin",myDIR);
	fi=fopen(buf,"rb");
	if(fi)
		{
		fread(&WmoRegs,sizeof(WMORGN),7,fi);
		fclose(fi);
		}

	for(i=0; i<7; i++)
		{
		l=WmoRegs[i].LinePntr+1;
		memset(&wmoPoints,0,sizeof(WMO_REGION_POINTS));

		for(y=0;y<l; y++)
			{
			wmoPoints.region=i+1;
			wmoPoints.count=0;
			for(k=0; k<WmoRegs[i].LineSize[y]; k++)
				{
				wmoPoints.p[wmoPoints.count].x=WmoRegs[i].LinePosLon[y][k];
				wmoPoints.p[wmoPoints.count++].y=WmoRegs[i].LinePosLat[y][k];
				}
			wmoPoints.p[wmoPoints.count].x=wmoPoints.p[0].x;
			wmoPoints.p[wmoPoints.count++].y=wmoPoints.p[0].y;
			}
		wmoRegions.Add(wmoPoints);
		}


//I use this list to fill the coordinate leaks in the table of AOKI
	sprintf(buf,"%s\\Data\\CityList.bin",myDIR);
	fi=fopen(buf,"rb");
	if(!fi) return;
	l=_filelength(_fileno(fi))/sizeof(LOCATION);
	myLocations.SetSize(l);
	fread(myLocations.GetData(),sizeof(LOCATION),myLocations.GetSize(),fi);
	fclose(fi);
}


int WINAPI CompareLoc(FRQLISTDAT &find,LOCATION &loc)
{
	char str1[256],str2[256];

	if(loc.name[0]==39||loc.name[0]==96) strcpy(str1,&loc.name[1]);	//ignore the first apostroph ' and 
	else strcpy(str1,loc.name);
	strupr(str1);

	if(find.db.location[0]==39||find.db.location[0]==96) strcpy(str2,&find.db.location[1]); 
	else strcpy(str2,find.db.location);
	strupr(str2);

	str1[strlen(str2)]=0;
	int v=strcmp(str2,str1);
	if(v) return v;

	if(find.db.country<loc.city.country) return -1;
	if(find.db.country>loc.city.country) return 1;
	return 0;
}

int WINAPI FindLoc(FRQLISTDAT &code)
{
	int		v,end,top=0,bot=0,mid,oldtop=-1,oldbot=-1;

	end=myLocations.GetSize();
	if(!end) return end;

	bot=end-1;


	v=CompareLoc(code,myLocations[bot]);
	if(v==0) goto set;
	if(v>0)	return end;
		
	while(top!=bot)
		{
		mid = ((top+bot)>>1);
		if(oldtop==top && oldbot==bot) 
			{
			return -1;
			}
		oldtop=top; oldbot=bot;
		v=CompareLoc(code,myLocations[mid]);
		if(v==0) {bot=mid; goto set;}
		if(v<0)	//check the uppers range
			{
			bot=mid; continue;
			}
		//check the lowers range 
		top=mid; 
		}
	 return -1;
set:

	if(myLocations[bot].city.DoubleFlags) 
		{
		return -1; //this name is twice, so the location can not really be identified
		}
	return bot;
}

void WINAPI FindLocation(FRQLISTDAT &code)
{
	int found=FindLoc(code);
	if(found>=0 && found<myLocations.GetSize())
		{
		code.db.lon=myLocations[found].lon;
		code.db.lat=myLocations[found].lat;
		code.db.RegionNr=myLocations[found].city.RegionNr; 
		}
	else
		{
		found=found;
		}
}


inline int isLeft(COORDIANTE *P0, COORDIANTE *P1, COORDIANTE P2 )
{
    return ( (P1->x - P0->x) * (P2.y - P0->y) - (P2.x - P0->x) * (P1->y - P0->y) );
}

BOOL  WINAPI IsPointInPolygon(COORDIANTE *rgpts, int wnumpts, COORDIANTE ptTest)
{
    int    i,wn = 0;    // the winding number counter
	COORDIANTE  *ppt ;

    // line through all edges of the polygon
	for (i = 0, ppt = rgpts ; i < wnumpts-1 ; i++, ppt++)
		{
        if (ppt->y <= ptTest.y) 
			{	// start y <= pt->y
            if ((ppt+1)->y > ptTest.y)      // an upward crossing
              if (isLeft(ppt, ppt+1, ptTest) > 0)  // P left of edge
                    ++wn;					// have a valid up intersect
			}
        else 
			{	// start y > P.y (no test needed)
			if ((ppt+1)->y <= ptTest.y)     // a downward crossing
              if (isLeft(ppt, ppt+1, ptTest) < 0)  // P right of edge
                    --wn;				// have a valid down intersect
			}
		}
    if (wn==0) return false;
	return true;
}

int WINAPI FindRegion(int x, int y) 
{
	int i;
	COORDIANTE	ptTest;

	ptTest.x=(short)x;
	ptTest.y=(short)y;
	for(i=0; i<wmoRegions.GetSize(); i++)
		{
		if(IsPointInPolygon(wmoRegions[i].p,wmoRegions[i].count,ptTest)) 
			{
			return wmoRegions[i].region; 	
			}
		}
	return 0;
}


LNG_List		myLNG;
SortIndex		mySortedLongLNG,mySortedShortLNG;


void WINAPI	Get_LNG() 
{
	FILE		*fi=0;
	int			i;
	char		buf[256];
	LNGCODE		code;

	myLNG.RemoveAll(); 

	//01234567890123456789
	//---,  ,   ,0   ,Undefined
	//abp,  ,   ,13  ,Abenlen Ayta
	mySortedShortLNG.SetSize(512);
	for(i=0; i<512; i++) mySortedShortLNG[i]=0;

	sprintf(buf,"%s\\InputList\\LNG-List.txt",FrqConvDir);
	fi=fopen(buf,"r");
	if(fi) 
		{
		while(!feof(fi))
			{
			fgets(buf,255,fi);
			if(buf[0]=='/') continue; 
			memset(&code,0,sizeof(LNGCODE));
			code.A3[0]=buf[0]; code.A3[1]=buf[1]; code.A3[2]=buf[2]; strlwr(code.A3); 
			code.A2[0]=buf[4]; code.A2[1]=buf[5]; strlwr(code.A2);
			buf[10]=0; code.shortNumber=atoi(&buf[7])&511;
			buf[15]=0; code.longNumber=atoi(&buf[11]);
			buf[65]=0; strcpy(code.Name,&buf[16]);
			Killspace(code.Name);
			myLNG.Add(code);
			if(code.shortNumber) mySortedShortLNG[code.shortNumber]=code.longNumber; 
			}
		fclose(fi);
		}
	else return;

	mySortedLongLNG.SetSize(myLNG.GetSize());
	for(i=0; i<myLNG.GetSize(); i++) mySortedLongLNG[i]=i;
}


void WINAPI	Get_ADM() 
{
	FILE		*fi=0;
	char		buf[256];
	ISOCODE_B	code;

	myADM.RemoveAll(); 

	//012345678901234567890123456789012345678901234567890123456789
	//---,0 ,Undefined
	//AFG Afghanistan                                        //
	mySortedADM.SetSize(256);
	for(int i=0; i<256; i++) mySortedADM[i]=0;

	sprintf(buf,"%s\\InputList\\ADM-List.txt",FrqConvDir);
	fi=fopen(buf,"r");
	if(fi) 
		{
		while(!feof(fi))
			{
			fgets(buf,255,fi);
			if(buf[0]=='/') continue; 
			memset(&code,0,sizeof(ISOCODE_B));
			code.A3[0]=buf[0]; code.A3[1]=buf[1]; code.A3[2]=buf[2]; strlwr(code.A3); 
			buf[7]=0; code.Number=atoi(&buf[4])&255;
			buf[54]=0; strcpy(code.Name,&buf[8]);
			Killspace(code.Name);
			myADM.Add(code);
			mySortedADM[code.Number]=code.Number; 
			}
		fclose(fi);
		}
	else return;
}


void WINAPI	GetIsoList(char *file, int max, IsoList &List,SortIndex &Idx) 
{

//realloc

	FILE		*fi=0;
	int			set=0;
	int			x,i,s,nr=0;
	char		buf[256];
	SortIndex	AlfaSortList;

	List.RemoveAll();
	List.SetSize(max);
	memset(List.GetData(),0,sizeof(ISOCODE_A)*max);

	//01234567890
	//AFG,AF,4  ,AFGHANISTAN
	//deu,de,143,German
	fi=fopen(file,"r");	
	if(fi) 
		{
		while(!feof(fi))
			{
			fgets(buf,255,fi);
			if(buf[0]=='/') continue; 
			buf[3]=0;
			buf[6]=0;
			buf[10]=0;
			buf[61]=0; //maximum = 50 chars
			nr=atoi(&buf[7]);
			if(nr<0 || nr>=max) nr=0;
			strlwr(buf);
			strcpy(List[nr].A3,buf);
			strlwr(&buf[4]);
			strcpy(List[nr].A2,&buf[4]);
			List[nr].Number=nr;	
			strcpy(List[nr].Name,&buf[11]);
			Killspace(List[nr].Name);
			}
		fclose(fi);
		}
	else return;


	AlfaSortList.SetSize(max);
	for(i=0; i<max; i++) AlfaSortList[i]=i;
	s=1;
	while(s)
		{
		for(i=2,s=0; i<max; i++)
			{
			if(strcmp(List[AlfaSortList[i-1]].Name,List[AlfaSortList[i]].Name)>0)
				{
				s=AlfaSortList[i-1];
				AlfaSortList[i-1]=AlfaSortList[i];
				AlfaSortList[i]=s;
				s=1;
				}
			}
		}

	for(x=i=0; i<max; i++) 
		{
		List[AlfaSortList[i]].sort=i;
		List[AlfaSortList[i]].item=-1;
		if(List[AlfaSortList[i]].Name[0])
			{
			List[AlfaSortList[i]].item=x++;
			List[AlfaSortList[i]].Number=AlfaSortList[i];
			Idx.Add(AlfaSortList[i]);
			}
		}
}

void WINAPI	GetStringList(char *file, CStringArray &List) 
{
	FILE		*fi=0;
	char		buf[256];
	CString		str;

	List.RemoveAll();

	fi=fopen(file,"r");	
	if(fi) 
		{
		while(!feof(fi))
			{
			fgets(buf,255,fi);
			if(buf[0]=='/') continue; 
			Killspace(buf);
			str=buf;
			List.Add(str);
			}
		fclose(fi);
		}
}

int WINAPI	FindOfCountries(char *country) 
{
	int i,j;
	if(country[0]==' ' && country[1]==' ') return 0;
	if(country[0]=='b' && country[1]==' ') return 76;
	if(country[0]=='f' && country[1]==' ') return 250;
	if(country[0]=='d' && country[1]==' ') return 276;
	if(country[0]=='i' && country[1]==' ') return 380;
	if(country[0]=='j' && country[1]==' ') return 392;
	if(country[0]=='e' && country[1]==' ') return 724;
	if(country[0]=='s' && country[1]==' ') return 752;
	if(country[0]=='g' && country[1]==' ') return 826;
	if(country[0]=='t' && country[1]=='k' && country[2]=='s') return 156; //china
	if(country[0]=='t' && country[1]=='i' && country[2]=='b') return 156; //china
	if(country[0]=='a' && country[1]=='r' && country[2]=='s') return 682; //saudi arabia
	if(country[0]=='m' && country[1]=='r' && country[2]=='a') return 840; //tinian island (USA)
	if(country[0]=='b' && country[1]=='i' && country[2]=='o') return 826; //Diego Garcia (UK) british indian ocean
	if(country[0]=='a' && country[1]=='s' && country[2]=='c') return 826; //Ascension (UK) 
	if(country[0]=='a' && country[1]=='l' && country[2]=='s') return 840; //Anchor Point (USA) alaska
	if(country[0]=='s' && country[1]=='r' && country[2]=='b') return 891; //Serbia
	if(country[0]=='r' && country[1]=='u' && country[2]=='v') return 643; //Russia
	if(country[0]=='s' && country[1]=='u' && country[2]=='i') return 756; //Switzerland
	if(country[0]=='k' && country[1]=='r' && country[2]=='e') return 408; //north Korea
	if(country[0]=='c' && country[1]=='v' && country[2]=='a') return 336; //Vatican


	for(i=0; i<mySortedCountries.GetSize(); i++)
		{
		if(!strcmp(country,myCountries[mySortedCountries[i]].A3))
			{
			return myCountries[mySortedCountries[i]].Number;
			}
		}

	j=-1;
	for(i=0; i<mySortedADM.GetSize(); i++)
		{
		if(!strcmp(country,myADM[mySortedADM[i]].A3))
			{
			j=mySortedADM[i];
			break;
			}
		}

	if(j!=-1)
	for(i=0; i<mySortedCountries.GetSize(); i++)
		{
		if(!strcmp(myADM[j].Name,myCountries[mySortedCountries[i]].Name))
			{
			return myCountries[mySortedCountries[i]].Number;
			}
		}

	return 0;
}

int WINAPI	GetIndexOfCountryA2(char *A2) 
{
	int		i;

	for(i=0; i<mySortedCountries.GetSize(); i++)
		{
		if(myCountries[mySortedCountries[i]].A2[0]==A2[0] && myCountries[mySortedCountries[i]].A2[1]==A2[1])
			{
			return myCountries[mySortedCountries[i]].Number;
			}
		}
	return 0;
}

int WINAPI	GetIndexOfLanguageA3(char *A3) 
{
	int		i;

	for(i=0; i<mySortedLanguages.GetSize(); i++)
		{
		if(myLanguages[mySortedLanguages[i]].A3[0]==A3[0] 
			&& myLanguages[mySortedLanguages[i]].A3[1]==A3[1]
			&& myLanguages[mySortedLanguages[i]].A3[2]==A3[2])
			{
			return myLanguages[mySortedLanguages[i]].Number;
			}
		}
	return 0;
}


#define BUF_FRQ		buf 
#define BUF_NAME	&buf[7] 
#define BUF_STRT	buf[37]
#define BUF_STRTM	buf[39]
#define BUF_STOP	buf[42]
#define BUF_STOPM	buf[44]
#define BUF_DAYS	buf[47]
#define BUF_LANG	buf[55]
#define BUF_POW		buf[80]
#define BUF_AZM		buf[85]
#define BUF_LOC		buf[90]
#define BUF_ADM		buf[113]
#define BUF_CALL	buf[132]
#define BUF_LAD		buf[157]
#define BUF_LAM		buf[162]
#define BUF_LOD		buf[166]
#define BUF_LOM		buf[172]


int WINAPI	find_Language(char *str)
{
	int	i;

	char cmp[256],buf[256];
	for(i=0; i<(int)strlen(str); i++)
		{
		if(!isalpha((int)str[i])) break;
		buf[i]=str[i];
		}
	buf[i]=0;
	_strupr(buf);

	for(i=0; i<myLNG.GetSize(); i++)
		{
		strcpy(cmp,myLNG[i].Name);
		_strupr(cmp); 
		if(!strcmp(buf,cmp)) return i;
		}
	return -1;
}

int WINAPI	FindLanguage(char *language) 
{
	if(language[strlen(language)-1]==',') language[strlen(language)-1]=0;
	for(int i=0; i<mySortedLanguages.GetSize(); i++)
		{
		if(!strcmp(language,myLanguages[mySortedLanguages[i]].Name))
			{
			return myLanguages[mySortedLanguages[i]].Number;
			}
		}
	return 0;
}

BOOL WINAPI	GetSingleChar(FRQLISTDAT	&code, char *oldname, char *newname) 
{
	char *find;
	find=strstr(code.db.name,oldname);
	if(find)
		{
		find--;
		if(find[0]==' ') return FALSE;
		}

	CString str;
	str=code.db.name;
	if(str.Replace(oldname,newname))
		{
		if(str.GetLength()>31) return FALSE;
		strncpy(code.db.name,str,31);
		code.db.name[31]=0;
		return TRUE;
		}
	return FALSE;
}

BOOL WINAPI	GetName(FRQLISTDAT	&code, char *oldname, char *newname) 
{
	CString str;
	str=code.db.name;
	if(str.Replace(oldname,newname))
		{
		if(str.GetLength()>31) return FALSE;
		strncpy(code.db.name,str,31);
		code.db.name[31]=0;
		return TRUE;
		}
	return FALSE;
}

BOOL WINAPI	GetLang(FRQLISTDAT	&code, char *oldname, char *newname) 
{
	CString str;
	str=code.db.language;
	if(str.Replace(oldname,newname))
		{
		if(str.GetLength()>31) return FALSE;
		strncpy(code.db.language,str,31);
		code.db.language[31]=0;
		return TRUE;
		}
	return FALSE;
}

int WINAPI cmpNames(char *name1,char *name2)
{
	char buf1[256];
	char buf2[256];

	if(name1[0]==39||name1[0]==96) strcpy(buf1,&name1[1]);	
	else strcpy(buf1,name1);	
	if(name2[0]==39||name2[0]==96) strcpy(buf2,&name2[1]);	
	else strcpy(buf2,name2);	

	_strupr(buf1);  _strupr(buf2);
	Killspace(buf1); Killspace(buf2);

	return strcmp(buf1,buf2);
}

int WINAPI	CompareItems(FRQLISTSET &ListData1, FRQLISTSET &ListData2) 
{
	int	ret=1;
	int lat1=(ListData1.lat+3)&3; 
	int lon1=(ListData1.lon+3)&3;
	int lat2=(ListData2.lat+3)&3; 
	int lon2=(ListData2.lon+3)&3;
	
	if(ListData2.frq>ListData1.frq) return -1;			
	if(ListData2.frq<ListData1.frq) return 1;

	if((lat1 || lon1) && (lat2 || lon2))
		{
		if(lat2>lat1) return -1; 
		if(lat2<lat1) return 1; 
		if(lon2>lon1) return -1; 
		if(lon2<lon1) return 1; 
		}
	else
		{
		ret=cmpNames(ListData1.name,ListData2.name);
		if(ret) return ret;
		}
	if(ListData1.schSet.sch_time_Days>ListData2.schSet.sch_time_Days) return -1; 
	if(ListData1.schSet.sch_time_Days<ListData2.schSet.sch_time_Days) return 1; 
	if(ListData1.schSet.sch_time_Start<ListData2.schSet.sch_time_Start) return -1;
	if(ListData1.schSet.sch_time_Start>ListData2.schSet.sch_time_Start) return 1; //the new is <<<<
	if(ListData1.schSet.sch_time_Stop<ListData2.schSet.sch_time_Stop) return -1;
	if(ListData1.schSet.sch_time_Stop>ListData2.schSet.sch_time_Stop) return 1; //the new is <<<<*/

	ret=cmpNames(ListData1.name,ListData2.name);
	if(ret) return ret;
	ret=cmpNames(ListData1.call,ListData2.call);
	if(ret) return ret;
	ret=cmpNames(ListData1.language,ListData2.language);
	if(ret) return ret;
	return NULL;
}

int WINAPI AddFrq(FRQLISTDAT &code)
{
	int		v,end,top=0,bot=0,mid,oldtop=-1,oldbot=-1;

	end=FrqData.GetSize();
	if(!end) {FrqData.Add(code); return end;}

	bot=end-1;

	v=CompareItems(code.db,FrqData[bot].db);
	if(v==0) goto set;
	if(v>0)	{FrqData.Add(code); return end;}
		
	while(top!=bot)
		{
		mid = ((top+bot)>>1);
		if(oldtop==top && oldbot==bot) break;
		oldtop=top; oldbot=bot;
		v=CompareItems(code.db,FrqData[mid].db);
		if(v==0) {bot=mid; goto set;}
		if(v<0)	//check the uppers bank
			{
			bot=mid; continue;
			}
		//check the lowers bank 
		top=mid; 
		}
set:
	//if v==0, then the data set was equal -- >we do not save equal data set
	if(v!=0) FrqData.InsertAt(bot,code);
	return bot;
}


#define BUFBIB_FRQ		buf 
#define BUFBIB_NAME		&buf[7] 
#define BUFBIB_STRT		buf[37]
#define BUFBIB_STRTM	buf[39]
#define BUFBIB_STOP		buf[42]
#define BUFBIB_STOPM	buf[44]
#define BUFBIB_DAYS		buf[47]
#define BUFBIB_LANG		buf[55]
#define BUFBIB_POW		buf[78]
#define BUFBIB_AZM		buf[83]
#define BUFBIB_LOC		buf[87]
#define BUFBIB_ADM		buf[110]
#define BUFBIB_CALL		buf[126]
#define BUFBIB_LONGLAT	buf[114]
#define BUFBIB_LLEND	buf[125]

char xstrA[16],XSTRa[16];

void WINAPI	Get_AOKI_BIB() 
{
//FREQ . STATION                       UTC       Su-W-Sa Language                Pow Azi Location               ADM         L/L Remarks                  Lat Min  Lon  Min
//  60   Time Signal                   0000-2400 1234567 A1B                      50  ND Haganeyama             J   13010E3328N NICT                      33  28  -130  10
//  855  DRadio Wissen(DRM)            0000-2400 1234567 German(Digital)          10  ND Berlin                 D   01335E5228N DR                        52  28  -13   35
//  234  RADIO Luxembourg              0000-2400 1234567 French                 2000  ND Beidweiler             LUX 00619E4944N RTL b11                   49  44   -6   19
// 11735 Zanzibar Broadcasting Corporat1500-1800 1234567 Swahili                  50  ND Dole                   TZA 03914E605S Zanzi                     6   5   -39   14
//------+-----------------------------+---------+-------+----------------------+----+---+----------------------+---+-----------+------------------------+---+----+----+---+----------
//012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
//;---------1---------2---------3---------4---------5---------6---------7---------8---------9---------10--------11--------12--------13--------14--------15--------16--------17---------

	FILE		*fi=0,*fo=0;
	char		*find,tmp[256],buf[256],day,ADM[4],pow[8],lola[16];
	FRQLISTDAT	code;
	int			max,pin=0,pset,i,x,len,loD,loM,laD,laM,lon,lat,tstop;
	CString		str;
	
	x=sizeof(FRQLISTSET);
	FrqData.RemoveAll(); 

	//01234567890123456789
	//---,0 ,Undefined
	mySortedTRG.SetSize(256);
	for(i=0; i<32; i++) mySortedTRG[i]=0;

	sprintf(buf,"%s\\InputList\\AOKIlist.txt",FrqConvDir);
	fi=fopen(buf,"r");

	sprintf(buf,"%s\\InputList\\AOKIMissingLocations.txt",FrqConvDir);
	fo=fopen(buf,"wb");

	if(fi) 
		{
		myProg->SetPos(100);

		max=(_filelength(_fileno(fi)));

		while(!feof(fi))
			{
			fgets(tmp,255,fi); strcpy(buf,tmp);
			len=strlen(buf); 
			pin+=len;
			pset=(int)(double)((100.0/(double)max)*(double)pin);
			myProg->SetPos(100+pset);
			
			len--;
			buf[len]=0;
			for(i=len; i<168; i++) buf[i]=' '; 
			if(buf[5]!='*') buf[5]=' ';
			if(buf[5]!='x') buf[5]=' ';
			if(buf[5]!=' ') continue;
			
			for(i=168; i>=5; i--) buf[i+1]=buf[i];
			

			buf[6]=buf[41]=buf[46]=buf[54]=buf[86]=buf[109]=buf[113]=buf[125]=buf[150]=buf[154]=buf[159]=buf[164]=buf[168]=0; 
			memset(&code,0,sizeof(FRQLISTDAT));
	
			code.db.fax.modul		=576;
			code.db.fax.speed		=120;		 
			code.db.fax.centerfrq	=1900;	 
			code.db.fax.shift		=800;	
			code.db.fax.filterwidth	=1200;
			code.db.fax.burst1		=1040;
			code.db.fax.burst2		=250;
			//code.db.fax.hmirror=0;	 
			//code.db.fax.vmirror=0;	 
			//code.db.fax.amfm=0;		 
			code.db.fax.filteronoff	=1;
			code.db.fax.filtermode	=2; 
			code.db.fax.syncwidth	=5;	 
			//code.db.fax.invertsync=0;
			//code.db.fax.SatID		=0;

			code.db.sstv.mode		=44;	//	SSTV_MODE_M1	
			code.db.sstv.synfrq		=1200;
			code.db.sstv.filterwidth=160;	
			code.db.sstv.filtertype	=0x04; //AIO_HANN;	
			code.db.sstv.filter_onoff=1;

			code.db.rtty.baud		=50;
			code.db.rtty.mark		=1275;
			code.db.rtty.space		=1700;
			code.db.rtty.stopbits	=1;
			//code.db.rtty.polarity	=0;
			//code.db.rtty.mode		=0=RTTY_MODE_BAUDOT;
			//code.db.rtty.RegLetter =0;

			code.db.cw.center=1275;		 
			code.db.cw.mark=1275;		 
			code.db.cw.width=50;

			code.db.modulation=RADIO_MODE_AM;
			code.db.modulationtype=11;
			code.db.stationtype=12;
			code.db.steps=1000;
			code.db.decoder=DEC_AUDIO;
			code.db.IFBandwidth=9000;

			code.db.frq=atoi(BUFBIB_FRQ)*1000;
			if(code.db.frq<100000) continue;
		
//			code.db.audio.startfrq=code.db.frq-12000;
//			code.db.audio.stopfrq=code.db.frq-12000;

			code.db.schSet.sch_time_Start=atoi(&BUFBIB_STRTM); BUFBIB_STRTM=0;
			code.db.schSet.sch_time_Start+=atoi(&BUFBIB_STRT)*60;
			code.db.schSet.sch_time_Stop=atoi(&BUFBIB_STOPM); BUFBIB_STOPM=0;
			code.db.schSet.sch_time_Stop+=atoi(&BUFBIB_STOP)*60;

			buf[37]=0;
			for(x=0,i=7; i<37; i++)
				{
				if(!buf[i]) break;
				code.db.name[x++]=buf[i];
				}
			code.db.name[x]=0;
			KillBothDir(code.db.name);

			if(!code.db.schSet.sch_time_Start && !code.db.schSet.sch_time_Stop) code.db.schSet.sch_time_Stop=1440; //0000-2400

			x=FRQ_DAYS_SU;
			for(i=0; i<7; i++)
				{
				day=0x31+i;
				if(buf[47+i]==day) code.db.schSet.sch_time_Days|=x;
				x>>=1;
				}
			pow[0]=buf[78];
			pow[1]=buf[79];
			pow[2]=buf[80];
			pow[3]=buf[81];
			if(buf[82]!=' ')
				{
				pow[4]=buf[82];
				pow[5]=0;
				}
			else pow[4]=0;

			code.db.PWR=(USHORT)(atof(pow)*10.);		// RadioJet calc this:  //if(PWR<=0x8000) then in .1 Watt else in 5 Watt steps	= ((PWR&0x7FFF)*5)

			buf[78]=0;
			strcpy(code.db.language,&BUFBIB_LANG); 
			find=strstr(code.db.language,"(Digital");
			if(find)
				{
				find[0]=0;
				buf[5]='D';
				}
			else
				{
				find=strstr(code.db.language,"(digital");
				if(find)
					{
					find[0]=0;
					buf[5]='D';
					}
				else
					{
					find=strstr(code.db.name,"(DRM)");
					if(find)
						{
						find[0]=0;
						buf[5]='D';
						}
					}
				}
			KillspaceSL(code.db.language);
			KillBothDir(code.db.language);
			GetLang(code,"Kyrgyz","Kirghiz");
			GetLang(code,"Romanian\"Curierul roman","Romanian (Curierul roman)");

			strcpy(code.db.location,&BUFBIB_LOC); 
			KillBothDir(code.db.location);
			strcpy(ADM,&BUFBIB_ADM);
			strlwr(ADM);
			code.db.country=FindOfCountries(ADM); 
			if(buf[5]=='D')
				{
				code.db.modulation=RADIO_MODE_DRM;
				code.db.IFBandwidth=12000;
				code.db.modulationtype=24;
				code.db.drm.CodecTypeIdx=1;
				code.db.drm.DataAudioTypeIdx=1;
				code.db.drm.LanguageIdx=FindLanguage(code.db.language);
				code.db.drm.CountryIdx=code.db.country;
				code.WorkFlag=FRQ_DRMSET;
				find=strstr(code.db.name,"(DRM)");
				if(find) find[0]=0;
				}

			buf[141]=0;
			strcpy(code.db.call,&BUFBIB_CALL); 
			find=strstr(code.db.call,xstrA);
			if(find) find[0]=0;
			find=strstr(code.db.call,XSTRa);
			if(find) find[0]=0;

			find=strstr(code.db.call,"//");
			if(find) find[0]=0;
			find=strstr(code.db.call,"/");
			if(find) find[0]=0;
			find=strstr(code.db.call,".");
			if(find) find[0]=0;
			find=strstr(code.db.call,"-");
			if(find) find[0]=0;
			find=strstr(code.db.call,"=");
			if(find) find[0]=0;
			find=strstr(code.db.call," R.");
			if(!find) 
				{
				find=strstr(code.db.call,".");
				if(find) find[0]=0;
				}
			find=strstr(code.db.call,"alt.");
			if(find) find[0]=0;

			KillBothDir(code.db.call);
			if(strstr(code.db.call,"your Ca")) code.db.call[0]=0;


			//lon / lat
			//456 78 9 01 234
			//006 19 E 49 44N//
			//013 24 E 52 48N DLR   
			if((buf[124]=='S' || buf[124]=='N') && (buf[119]=='W' || buf[119]=='E'))
				{
				lola[0]=buf[114]; 
				lola[1]=buf[115];
				lola[2]=buf[116];
				lola[3]=':';
				lola[4]=buf[117];
				lola[5]=buf[118];
				lola[6]=':';
				lola[7]=buf[120];
				lola[8]=buf[121];
				lola[9]=':';
				lola[10]=buf[122];
				lola[11]=buf[123];
				lola[12]=0;

				sscanf(lola,"%03d:%02d:%02d:%02d",&loD,&loM,&laD,&laM);

				lon=(loD*60)+loM;
				lat=(laD*60)+laM;

				if(buf[124]=='N') code.db.lat=-lat;
				else code.db.lat=lat;
				if(buf[119]=='W') code.db.lon=-lon;
				else code.db.lon=lon;
				code.db.RegionNr=FindRegion(code.db.lon,code.db.lat); 
				}
			else 
				{
				buf[154]=buf[159]=buf[164]=buf[168]=0;
				//lish                   1  ND Goderich               SRL  01314W830N UNAMS                     8   3    13   14			
				code.db.lat=(atoi(&buf[151])*60)+atoi(&buf[155]);
				code.db.lon=(atoi(&buf[160])*60)+atoi(&buf[165]);
				code.db.RegionNr=FindRegion(code.db.lon,code.db.lat); 
				}
				
			find=strstr(code.db.name,"Monaco Radio");
			if(find)
				{
				strcpy(code.db.call,"3AC");
				code.db.modulation=RADIO_MODE_USB;
				code.db.modulationtype=18;
				code.db.IFBandwidth=3000;
				}
			find=strstr(code.db.name,"Radio Dniprovska Hvylya");
			if(find)
				{
				strcpy(code.db.call,"PPRK");
				code.db.modulation=RADIO_MODE_USB;
				code.db.modulationtype=18;
				code.db.IFBandwidth=3000;
				}

			find=strstr(code.db.name,"Radio MAYAK");
			if(!find) find=strstr(code.db.name,"R.MAYAK");
			if(find)
				{
				strcpy(code.db.name,"Radio Mayak"); 
				strcpy(code.db.location,"Moscow"); //55N45:037E36
				code.db.lon=2256;
				code.db.lat=-3345;			
				goto end;
				}

			find=strstr(code.db.location,"Athinai");
			if(find)
				{
				strcpy(code.db.location,"Athens"); 
				code.db.lon=1422;
				code.db.lat=-2278;			
				goto end;
				}

			find=strstr(code.db.location,"Kazan");
			if(find)
				{
				//55N47:049E07
				code.db.lon=2947;
				code.db.lat=-3347;			
				goto end;
				}

		
			find=strstr(code.db.location,"Sankt-Petersburg");
			if(!find) find=strstr(code.db.location,"St.Petersburg");
			if(find)
				{
				//59N53:030E15
				strcpy(code.db.location,"Saint Petersburg"); 
				code.db.lon=1815;
				code.db.lat=-3593;			
				goto end;
				}
			find=strstr(code.db.location,"Col de la Madone");
			if(find)
				{
				//43N47:07E25
				code.db.lon=445;
				code.db.lat=-2627;			
				goto end;
				}

			find=strstr(code.db.location,"Galliera (Bologna)");
			if(find)
				{
				//44N44:011E23
				strcpy(code.db.location,"Galliera"); 
				code.db.lon=683;
				code.db.lat=-2684;			
				goto end;
				}
			find=strstr(code.db.location,"Zeewolde (Flevoland)");
			if(find)
				{
				//52N19:005E32
				strcpy(code.db.location,"Zeewolde"); 
				code.db.lon=332;
				code.db.lat=-3139;			
				goto end;
				}

			find=strstr(code.db.location,"Little Shurdington");
			if(find)
				{
				//51N51:002W07
				strcpy(code.db.location,"Shurdington"); 
				code.db.lon=-127;
				code.db.lat=-3111;			
				goto end;
				}
			find=strstr(code.db.location,"Leipzig-Wiederau");
			if(find)
				{
				//:51N20:012E22
				strcpy(code.db.location,"Leipzig"); 
				code.db.lon=742;
				code.db.lat=-3080;			
				goto end;
				}
			find=strstr(code.db.location,"Electrostal");
			if(find)
				{
				//55N47:038E26
				strcpy(code.db.location,"Elektrostal\'"); 
				code.db.lon=2306;
				code.db.lat=-3347;			
				goto end;
				}
			find=strstr(code.db.location,"Kostinbrod(Sofia)");
			if(find)
				{
				//42N49:023E13
				strcpy(code.db.location,"Kostinbrod"); 
				code.db.lon=1393;
				code.db.lat=-2569;			
				goto end;
				}
			find=strstr(code.db.location,"Pietersbierum");
			if(find)
				{
				//53N12:005E28
				code.db.lon=328;
				code.db.lat=-3192;			
				goto end;
				}
			find=strstr(code.db.location,"Novosibrisk");
			if(find)
				{
				//55N02:082E56
				strcpy(code.db.location,"Novosibirsk"); 
				code.db.lon=4976;
				code.db.lat=-3302;			
				goto end;
				}
			find=strstr(code.db.location,"Berlin-Britz");
			if(find)
				{
				//52N31:013E24
				strcpy(code.db.location,"Berlin"); 
				code.db.lon=804;
				code.db.lat=-3151;			
				goto end;
				}

			find=strstr(code.db.location,"Corfu");
			if(find)
				{
				//3940'N 1945'E
				code.db.lon=1185;
				code.db.lat=-2340;			
				goto end;
				}

			find=strstr(code.db.location,"Paris - Villebon-sur-YvF");
			if(find)
				{
				//48N51:002E20
				strcpy(code.db.location,"Paris"); 
				code.db.lon=140;
				code.db.lat=-2931;			
				goto end;
				}
			find=strstr(code.db.location,"Moorside Edge");
			if(find)
				{
				//53N38:001W54:GBR:Moorside Edge (Huddersfield)   
				strcpy(code.db.location,"Moorside Edge (Huddersfield)"); 
				code.db.lon=-114;
				code.db.lat=-3218;			
				goto end;
				}
			find=strstr(code.db.location,"Sighet Maramuresh");
			if(find)
				{
				//47N55:023E53
				strcpy(code.db.location,"Sighetu Marmatiei"); 
				code.db.lon=1433;
				code.db.lat=-2875;			
				goto end;
				}
			find=strstr(code.db.location,"Baia Mare");
			if(find)
				{
				//47N39:023E34
				strcpy(code.db.location,"Baia Mare"); 
				code.db.lon=1414;
				code.db.lat=-2859;			
				goto end;
				}
			find=strstr(code.db.location,"Tancabesti");
			if(find)
				{
				//44N42:026E10:
				strcpy(code.db.location,"Snagov"); 
				code.db.lon=1570;
				code.db.lat=-2682;			
				goto end;
				}
			find=strstr(code.db.location,"Galbeni-Bacau");
			if(find)
				{
				//46N34:026E54:ROU:Bacau             
				strcpy(code.db.location,"Bacau"); 
				code.db.lon=1614;
				code.db.lat=-2794;			
				goto end;
				}
			find=strstr(code.db.location,"Galati");
			if(find)
				{
				//45N27:028E03:ROU:Galati  
				strcpy(code.db.location,"Galati"); 
				code.db.lon=1683;
				code.db.lat=-2727;			
				goto end;
				}
			find=strstr(code.db.location,"Ion Korvinn");
			if(find)
				{
				//44N07:027E48:ROU:Ion Corvin             
				strcpy(code.db.location,"Ion Corvin"); 
				code.db.lon=1668;
				code.db.lat=-2827;			
				goto end;
				}
			find=strstr(code.db.location,"Murmansk/");
			if(find)
				{
				//68N58:033E05:RUS:Murmansk
				strcpy(code.db.location,"Murmansk"); 
				code.db.lon=1985;
				code.db.lat=-4138;			
				goto end;
				}
			find=strstr(code.db.location,"Marseille-Cabries");
			if(find)
				{
				//43N17:005E22:FRA:Marseille 
				strcpy(code.db.location,"Marseille"); 
				code.db.lon=322;
				code.db.lat=-2597;			
				goto end;
				}

			find=strstr(code.db.location,"Bordeaux");
			if(find)
				{
				//44N50:000W34:FRA:Bordeaux
				strcpy(code.db.location,"Bordeaux"); 
				code.db.lon=-34;
				code.db.lat=-2690;			
				goto end;
				}
			find=strstr(code.db.location,"Postwick");
			if(find)
				{
				//52N37:001E17:GBR:Norwich
				strcpy(code.db.location,"Norwich"); 
				code.db.lon=77;
				code.db.lat=-3157;			
				goto end;
				}

			if(GetName(code,"VOICE OF RUSSIA(V.of Mongolia)","Voice of Russia (V.of Mongolia)"))  goto end;
			if(GetName(code,"VOICE OF RUSSIA","Voice of Russia"))  goto end;
			if(GetName(code,"VOICE OF AMERICA","Voice of America"))  goto end;
			if(GetName(code,"R.FRANCE INT.","Radio France International"))  goto end;
			if(GetName(code,"CHINA RADIO INTER.","Radio China International"))  goto end;
			if(GetName(code,"R.CANADA INT.","Radio Canada International"))  goto end;
			if(GetName(code,"R.TAIWAN INT.","Radio Taiwan International"))  goto end;
			if(GetName(code,"R.ROMANIA INT.","Radio Romania International"))  goto end;
			if(GetName(code,"R.FINLAND","Radio Finland"))  goto end;
			if(GetName(code,"R.JAPAN","Radio Japan"))  goto end;
			if(GetName(code,"R.Slovakia Int.","Radio Slovakia International"))  goto end;
			if(GetName(code,"R.Prague","Radio Prague"))  goto end;
			if(GetName(code,"KBS WORLD RADIO","KBS World Radio"))  goto end;
			if(GetName(code,"R.POLONIA","Radio Polonia"))  goto end;
			if(GetName(code,"FAMILY RADIO","Family Radio"))  goto end;
			if(GetName(code,"R.BULGARIA","Radio Bulgaria"))  goto end;
			if(GetName(code,"R.Sakha-R.Rossii","Radio Sakha / Radio Rossii"))  goto end;
			if(GetName(code,"R.Rossii","Radio Rossii"))  goto end;
			if(GetName(code,"R.Sakha","Radio Sakha"))  goto end;
			if(GetName(code,"R.LIBERTY","Radio Liberty"))  goto end;
			if(GetName(code,"VO ISLAMIC REP.IRAN","Voice of islamic Rep. Iran"))  goto end;
			if(GetName(code,"VO IRANIAN KURDISTAN","Voice of Iranian Kurdistan"))  goto end;
			if(GetName(code,"VO KURDISTAN TOILERS",""))  goto end;
			if(GetName(code,"AFN LOS ANGELES","AFN Los Angeles"))  goto end;
			if(GetName(code,"VO IRANIAN COMUN.PARTY","Voice of Iranian Comun. Party"))  goto end;
			if(GetName(code,"R.VOICE OF PEOPLE","Radio Voice of People"))  goto end;
			if(GetName(code,"VOICE OF THE PEOPLE","Voice of the People"))  goto end;
			if(GetName(code,"KYRGYZ RADIO","Kirghiz Radio"))  goto end;
			if(GetName(code,"ALL INDIA RADIO","All India Radio"))  goto end;
			if(GetName(code,"AIR VOICE OF KASHMIR","Air Voice of Kashmir"))  goto end;
			if(GetName(code,"R.HABANA CUBA","Radio Habana Cuba"))  goto end;
			if(GetName(code,"VO OROMO LIBERATION","Voice of Oromo Liberation"))  goto end;
			if(GetName(code,"WWCR NASHVILLE","WWCR Nashville"))  goto end;
			if(GetName(code,"VOICE OF PUJIANG","Voice of Pujiang"))  goto end;
			if(GetName(code,"R.PAKISTAN","Radio Pakistan"))  goto end;
			if(GetName(code,"VATICAN RADIO","Vatican Radio"))  goto end;
			if(GetName(code,"DEUTSCHE WELLE","Deutsche Welle"))  goto end;
			if(GetName(code,"BIBLE VOICE BCN","Bible Voice BCN"))  goto end;
			if(GetName(code,"R.NEW ZEALAND INT.","Radio New Zealand International"))  goto end;
			if(GetName(code,"R.NEDERLAND","Radio Nederland"))  goto end;
			if(GetName(code,"VOICE OF VIETNAM","Voice of Vietnam"))  goto end;
			if(GetName(code,"VOICE OF TURKEY","Voice of Turkey"))  goto end;
			if(GetName(code,"R.EXTERIOR DE ESPANA","Radio Exterior de Espana"))  goto end;
			if(GetName(code,"ADVENTIST WORLD R.","Adventist World Radio"))  goto end;
			if(GetName(code,"R.AUSTRALIA","Radio Australia"))  goto end;
			if(GetName(code,"R.MALI","Radio Mali"))  goto end;
			if(GetName(code,"ECHO OF HOPE-VOH","Echo of Hope-VOH"))  goto end;
			if(GetName(code,"SRI LANKA","Sri Lanka"))  goto end;
			if(GetName(code,"R.FREE ASIA","Radio Free Asia"))  goto end;
			if(GetName(code,"R.BAHRAIN","Radio Bahrain"))  goto end;
			if(GetName(code,"PAN AMERICAN","Pan American"))  goto end;
			if(GetName(code,"HCJB QUITO","HCJB Quito"))  goto end;
			if(GetName(code,"VOICE OF ISLAM","Voice of Islam"))  goto end;
			if(GetName(code,"RADIO NIKKEI","Radio Nikkei"))  goto end;
			if(GetName(code,"R.ARGENTINA EXTERIOR","Radio Argentina Exterior"))  goto end;
			if(GetName(code,"R.NACIONAL ARGENTINA","Radio Nacional Argentina"))  goto end;
			if(GetName(code,"R.SERBIA INT.","Radio Serbia International"))  goto end;
			if(GetName(code,"VOICE OF AZERBAIJAN","Voice of Azerbaijan"))  goto end;
			if(GetName(code,"R.VERITAS ASIA","Radio Veritas Asia"))  goto end;
			if(GetName(code,"VOICE OF STRAIT","Voice od Strait"))  goto end;
			if(GetName(code,"FEBA RADIO","Feba Radio"))  goto end;
			if(GetName(code,"SHIOKAZE","Shiokaze"))  goto end;
			if(GetName(code,"R.BELARUS","Radio Belarus"))  goto end;
			if(GetName(code,"R.OESTERREICH INT.","Radio stereich International"))  goto end;
 			if(GetName(code,"R.Algerienne Holy Qur`an","Radio Algerienne Holy Qur`an"))  goto end;
			if(GetName(code,"R.MARTI","Radio Marti"))  goto end;
			if(GetName(code,"R.Myanmar","Radio Myanmar"))  goto end;
			if(GetName(code,"FEBC MANILA","FEBC Manila"))  goto end;
			if(GetName(code,"R.ETHIOPIA","Radio Ethiopia"))  goto end;
			if(GetName(code,"Deutsches R Sweden","Deutsches Radio Sweden"))  goto end;
			if(GetName(code,"Deutsches R. Belarus","Deutsches Radio Belarus"))  goto end;
			if(GetName(code,"Deutsches R.Joystick","Deutsches Radio Joystick"))  goto end;
			if(GetName(code,"TDP The Disco Palace","TDC-Radio - The Disco Palace"))  goto end;
			if(GetName(code,"TDP RADIO","TDC-Radio - The Disco Palace"))  goto end;
			if(GetName(code,"VO Tanzania Zanzibar","Voice of Tanzania Zanzibar"))  goto end;
			if(GetName(code,"R.Universo Internacional","Radio Universo Internacional"))  goto end;
			if(GetName(code,"CVC INTERNATIONAL","CVC International"))  goto end;
			if(GetName(code,"R.Mauro Nunez","Radio Mauro Nunez"))  goto end;
			if(GetName(code,"R.Bandeirantes","Radio Bandeirantes"))  goto end;
			if(GetName(code,"R.Nigeria Kaduna","Radio Nigeria Kaduna"))  goto end;
			if(GetName(code,"R.Universal","Radio Universal"))  goto end;
			if(GetName(code,"R.Cancao Nova","Radio Cancao Nova"))  goto end;
			if(GetName(code,"R.Filadelfia","Radio Filadelfia"))  goto end;
			if(GetName(code,"R.Primero de Marzo","Radio Primero de Marzo"))  goto end;
			if(GetName(code,"R.Universidad Cta.Rica","Radio Universidad Cta.Rica"))  goto end;
			if(GetName(code,"R.Fana","Radio Fana"))  goto end;
			if(GetName(code,"R.Union","Radio Union"))  goto end;
			if(GetName(code,"R.Globo","Radio Globo"))  goto end;
			if(GetName(code,"COAL.MARITIME FORCES","Caol.Maritime Forces"))  goto end;
			if(GetName(code,"R.Aparecida","Radio Aparecida"))  goto end;
			if(GetName(code,"R.Yemen","Radio Yemen"))  goto end;
			if(GetName(code,"R.Madagasikara","Radio Madagasikara"))  goto end;
			if(GetName(code,"R.CYPRUS","Radio Cyprus"))  goto end;
			if(GetName(code,"R.Santa Cruz","Radio Santa Cruz"))  goto end;
			if(GetName(code,"R.Bujumbura","Radio Bujumbura"))  goto end;
			if(GetName(code,"R.Gloria International","Radio Gloria International"))  goto end;
			if(GetName(code,"R.Melodia","Radio Melodia"))  goto end;
			if(GetName(code,"R.Cad.Peruana Noticias","Radio Cad.Peruana Noticias"))  goto end;
			if(GetName(code,"R.Record","Radio Record"))  goto end;
			if(GetName(code,"CHANNEL AFRICA","Channel Africa"))  goto end;
			if(GetName(code,"R.Fides","Radio Fides"))  goto end;
			if(GetName(code,"R.(GFA)","Radio (GFA)"))  goto end;
			if(GetName(code,"R.Boa Ventade","Radio Boa Ventade"))  goto end;
			if(GetName(code,"R.Logos","Radio Logos"))  goto end;
			if(GetName(code,"R.N'Djamena","Radio N'Djamena"))  goto end;
			if(GetName(code,"R.Cultura","Radio Cultura"))  goto end;
			if(GetName(code,"Scandinav.Weekend R.","Scandinavian Weekend Radio"))  goto end;
			if(GetName(code,"R.Tawantinsuyo","Radio Tawantinsuyo"))  goto end;
			if(GetName(code,"WHRI CYPRESS","WHRI Cypress"))  goto end;
			if(GetName(code,"R.Nacional de Venezuela","Radio Nacional de Venezuela"))  goto end;
			if(GetName(code,"R.Oriente","Radio Oriente"))  goto end;
			if(GetName(code,"XEPPM R.Educacion","XEPPM Radio Educacion"))  goto end;
			if(GetName(code,"R.Cusco","Radio Cusco"))  goto end;
			if(GetName(code,"R.Kahuzi","Radio Kahuzi"))  goto end;
			if(GetName(code,"R.Baluarte","Radio Baluarte"))  goto end;
			if(GetName(code,"DEM.VOICE OF BURMA","Dem.Voice of Burma"))  goto end;
			if(GetName(code,"Radyo-e Rahoya Iran(Oghabe Ira","Radyo-e Rahoya Iran (Oghabe)"))  goto end;
			if(GetName(code,"PYONGYANG","Pyongyang"))  goto end;
			if(GetName(code,"R.CAIRO","Radio Cairo"))  goto end;
			if(GetName(code,"Nat.R.of Sahara ArabD Rep.","Nat.Radio of Sahara ArabD Rep."))  goto end;
			if(GetName(code,"VO IRAQI KURDISTAN","Voice of Iraqi Kurdistan"))  goto end;
			if(GetName(code,"R.Calemar Nuevo","Radio Calemar Nuevo"))  goto end;
			if(GetName(code,"R.Dien Bien Phu","Radio Dien Bien Phu"))  goto end;
			if(GetName(code,"R.Altura","Radio Altura"))  goto end;
			if(GetName(code,"R.Cao Bang","Radio Cao Bang"))  goto end;
			if(GetName(code,"R.Paucartambo","Radio Paucartambo"))  goto end;
			if(GetName(code,"R.El Libertado","Radio El Libertado"))  goto end;
			if(GetName(code,"R.Dif.Huancabamba","Radio Dif.Huancabamba"))  goto end;
			if(GetName(code,"R.Comercial","Radio Comercial"))  goto end;
			if(GetName(code,"R.Nueva Esperanza","Radio Nueva Esperanza"))  goto end;
			if(GetName(code,"R.Lao Cai","Radio Lao Cai"))  goto end;
			if(GetName(code,"R.Sensacion","Radio Sensacion"))  goto end;
			if(GetName(code,"R.Satelite","Radio Satelite"))  goto end;
			if(GetName(code,"R.Ondas del Pacifico","Radio Ondas del Pacifico"))  goto end;
			if(GetName(code,"Turkiye Meteorolog.R.","Turkiye Meteorologic Radio"))  goto end;
			if(GetName(code,"(Dimtsi Hafas"," (Dimtsi)"))  goto end;
			if(GetName(code,"R.Conakry","Radio Conakry"))  goto end;
			if(GetName(code,"R.Hargeisa","Radio Hargeisa"))  goto end;
			if(GetName(code,"S-AFRICAN RADIO LEAGUE","South African Radio League"))  goto end;
			if(GetName(code,"TUNISIA","Tunesia"))  goto end;
			if(GetName(code,"R.Mauritanie","Radio Mauritanie"))  goto end;
			if(GetName(code,"VOICE OF TAJIK","Voice of Tajik"))  goto end;
			if(GetName(code,"R.BANGLADESH BETAR","Radio Bangladesh Betar"))  goto end;
			if(GetName(code,"R.KUWAIT","Radio Kuwait"))  goto end;
			if(GetName(code,"R.THAILAND","Radio Thailand"))  goto end;
			if(GetName(code,"R.Vanuatu","Radio Vanuatu"))  goto end;
			if(GetName(code,"R.FARDA","Radio Farda"))  goto end;
			if(GetName(code,"R.SONDER GRENSE","Radio Sonder Grense"))  goto end;
			if(GetName(code,"(The Overcomer Mini","(The Overcomer ...)"))  goto end;
			if(GetName(code,"R.PILIPINAS","Radio Pilipinas"))  goto end;
			if(GetName(code,"R.AFRICA","Radio Africa"))  goto end;
			if(GetName(code," GUAM "," Guam "))  goto end;
			if(GetName(code,"R.RIYADH","Radio Riyadh"))  goto end;
			if(GetName(code,"R.JORDAN","Radio Jordan"))  goto end;
			if(GetName(code,"VOICE OF NIGERIA","Voice of Nigeria"))  goto end;
			if(GetName(code,"VOICE OF MONGOLIA","Voice of Mongolia"))  goto end;
			if(GetName(code,"VOICE OF JINLING","Voice of Jinling"))  goto end;
			if(GetName(code,"VOICE OF INDONESIA","Voice of Indonesia"))  goto end;
			if(GetName(code,"VOICE OF GREECE","Voice of Greece"))  goto end;
			if(GetName(code,"VOICE OF CHINA","Voice of China"))  goto end;
			if(GetName(code,"VOICE OF ARMENIA","Voice of Armenia"))  goto end;
			if(GetName(code,"VO DEM.ALLIANCE","Voice of dem.Alliance"))  goto end;
			if(GetName(code,"VO IRANIAN REVOLUTION","Voice of iranian Revolution"))  goto end;
			if(GetName(code,"VO Beibu Bay Radio","Voice of Beibu Bay Radio"))  goto end;
			if(GetName(code,"VO Peace &Democracy","Voice of Peace & Democracy"))  goto end;
			if(GetName(code,"VO Tigray Revolution","Voice of Tigray Revolution"))  goto end;
			if(GetName(code,"VOICE OF AFRICA","Voice of Africa"))  goto end;
			if(GetName(code,"VOICE OF HAN","Voice of Han"))  goto end;
			if(GetName(code,"VOICE OF TIBET","Voice of Tibet"))  goto end;
			if(GetName(code,"XINHUA Beijing","Xinhua Beijing"))  goto end;
			if(GetName(code,"XNA Beijing","Xinhua Beijing"))  goto end;
			if(GetName(code,"R.TIRANA","Radio Tirana"))  goto end;
			if(GetName(code,"R.TATARSTAN","Radio Tatarstan"))  goto end;
			if(GetName(code,"R.SULTANATE OMAN","Radio Sultanate Oman"))  goto end;
			if(GetName(code,"RADIO SARANROM","Radio Saranrom"))  goto end;
			if(GetName(code,"AIR R.KASHMIR SRINAGAR","Air Radio Kashmir Srinagar"))  goto end;
			if(GetName(code,"CROATIAN RADIO","Croatian Radio"))  goto end;
			if(GetName(code,"DEEWA RADIO","Deewa Radio"))  goto end;
			if(GetName(code,"FRONTLINE SOLDIERS R.","Frontline Soldiers Radio"))  goto end;
			if(GetName(code,"GALEI ZAHAL","Galai Zahal"))  goto end;
			if(GetName(code,"HCJB AUSTRALIA","HCJB Australia"))  goto end;
			if(GetName(code,"IBRA RADIO","IBRA Radio"))  goto end;
			if(GetName(code,"KJES VADO","Kjes Vado"))  goto end;
			if(GetName(code,"KNLS ANCHOR POINT","KNLS Anchor Point"))  goto end;
			if(GetName(code,"KSDA-AWR GUAM","KSDA-AWR Guam"))  goto end;
			if(GetName(code,"KTWR GUAM","KTWR Guam"))  goto end;
			if(GetName(code,"MASHAAL RADIO","Mashaal Radio"))  goto end;
			if(GetName(code,"R.PILIPINAS(r.Radyo Magasin)","Radio Pilipinas, Radyo Magasin"))  goto end;
			if(GetName(code,"R.PILIPINAS(r.Radyo ng Bayan)","Radio Pilipinas, Radyo Bayan"))  goto end;
			if(GetName(code,"R.Sauti ya Injili(Vo Gospel) L","Radio Sauti ya Injili (Gospel)"))  goto end;
			if(GetName(code,"RADIO 9 DE JULHO","Radio 9 de Julho"))  goto end;
			if(GetName(code,"R.ASHUR-V.ASSYRIAN REP","Radio Ashur-V.Assyrian Rep."))  goto end;
			if(GetName(code,"RADIO AZADI","Radio Azadi"))  goto end;
			if(GetName(code,"RADIO ABANGA","Radio Dabanga"))  goto end;
			if(GetName(code,"RADIO DAMASCUS","Radio Damascus"))  goto end;
			if(GetName(code,"R.FREE IRAQ ","Radi Free Iraq"))  goto end;
			if(GetName(code,"R.MAKEDONIAS","Radio Makedonias"))  goto end;
			if(GetName(code,"R.MARIA France","Radio Maria France"))  goto end;
			if(GetName(code,"R.MEDITERRANEE Int.","Radio Mediterran Internatinal"))  goto end;
			if(GetName(code,"R.MIRAYA ","Radio Miraya"))  goto end;
			if(GetName(code,"R.PMR (R.PRIDNESTROVYE)","Radio PMR, Radio Pridnestrovye"))  goto end;
			if(GetName(code,"R.PORTUGAL INT.","Radio Portugal International"))  goto end;
			if(GetName(code,"R.REBELDE","Radio Rebelde"))  goto end;
			if(GetName(code,"R.SAWA","Radio SAWA"))  goto end;
			if(GetName(code,"R.TAIWAN INT.(KEBR)","Radio Taiwan Internat. (KEBR)"))  goto end;
			if(GetName(code,"R.TAIWAN INT.(WBGR)","Radio Taiwan Internat. (WBGR)"))  goto end;
			if(GetName(code,"RN DA AMAZONIA","Radio da Amaazonia"))  goto end;
		

			/*	if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;
			if(GetName(code,"",""))  goto end;*/

			if(GetName(code,"RADIO","Radio"))  goto end;
			if(GetName(code,"R.","Radio "))  goto end;
end:	
			if(GetSingleChar(code,"("," ("))  goto end;
			code.db.name[31]=0;

			if(code.db.schSet.sch_time_Stop<code.db.schSet.sch_time_Start) 
				{
				tstop=code.db.schSet.sch_time_Stop;
				code.db.schSet.sch_time_Stop=1440;
				AddFrq(code);
				code.db.schSet.sch_time_Stop=tstop;
				code.db.schSet.sch_time_Start=0;
				}
			
			if(myLocations.GetSize() && !code.db.lat && !code.db.lon) 
				{
				FindLocation(code);
				if(!code.db.lat && !code.db.lon) 
					{
					fputs(tmp,fo);
					}
				}

			AddFrq(code);
			}
		fclose(fi);
		fclose(fo);
		}
	else return;
}

void WINAPI	GetTables() 
{
	char		buf[256];
	sprintf(buf,"%s\\Data\\LanguageList.txt",myDIR);
	GetIsoList(buf,500,myLanguages,mySortedLanguages);

	sprintf(buf,"%s\\Data\\CountryList.txt",myDIR);
	GetIsoList(buf,1000,myCountries,mySortedCountries);

	sprintf(buf,"%s\\Data\\RegionsList.txt",myDIR);
	GetStringList(buf,myRegionsList);

	myProgramTypes.Add("mixed program");		//0  DRM_PG_MIX				
	myProgramTypes.Add("News");					//1  DRM_PG_NEWS			
	myProgramTypes.Add("Current Affairs");		//2  DRM_PG_AFFAIRS			
	myProgramTypes.Add("Information");			//3  DRM_PG_INFOS			
	myProgramTypes.Add("Sport");				//4  DRM_PG_SPORT				
	myProgramTypes.Add("Education");			//5  DRM_PG_EDUCATION		
	myProgramTypes.Add("Drama");				//6  DRM_PG_DRAMA				
	myProgramTypes.Add("Culture");				//7  DRM_PG_CULTURE		
	myProgramTypes.Add("Science");				//8  DRM_PG_SCINCE				
	myProgramTypes.Add("Varied");				//9  DRM_PG_VARIED			
	myProgramTypes.Add("Pop Music");			//10 DRM_PG_POP				
	myProgramTypes.Add("Rock Music");			//11 DRM_PG_ROCK			
	myProgramTypes.Add("Easy Music");			//12 DRM_PG_EASY				
	myProgramTypes.Add("Light Classical");		//13 DRM_PG_LIGHT			
	myProgramTypes.Add("Serious Classical");	//14 DRM_PG_SERIOUS			
	myProgramTypes.Add("Other Music");			//15 DRM_PG_OTHER			
	myProgramTypes.Add("Weather");				//16 DRM_PG_WEATHER			
	myProgramTypes.Add("Finance/Business");		//17 DRM_PG_FINANCE		
	myProgramTypes.Add("Children Program");		//18 DRM_PG_CHILDREN			
	myProgramTypes.Add("Social Affairs");		//19 DRM_PG_SOCIAL			
	myProgramTypes.Add("Religion");				//20 DRM_PG_RELIGION			
	myProgramTypes.Add("Phone In");				//21 DRM_PG_PHONE			
	myProgramTypes.Add("Travel");				//22 DRM_PG_TRAVEL				
	myProgramTypes.Add("Leisure");				//23 DRM_PG_LEISURE		
	myProgramTypes.Add("Jazz Music");			//24 DRM_PG_JAZZ				
	myProgramTypes.Add("Country Music");		//25 DRM_PG_COUNTRY		
	myProgramTypes.Add("National Music");		//26 DRM_PG_NATIONAL			
	myProgramTypes.Add("Oldies Music");			//27 DRM_PG_OLDIES			
	myProgramTypes.Add("Folk Music");			//28 DRM_PG_FOLK				
	myProgramTypes.Add("Documentary");			//29 DRM_PG_DOCU			
	myProgramTypes.Add("hamradio");				//30 DRM_PG_HAMRADIO			
	myProgramTypes.Add("contest");				//31 DRM_PG_CONTEST	
	
	DataAudioTypes.Add("undefined");			//0  DRM_AD_UNKNOW		
	DataAudioTypes.Add("Mono");					//1  DRM_AD_MONO		
	DataAudioTypes.Add("P-Stereo");				//2  DRM_AD_PSTEREO	
	DataAudioTypes.Add("Stereo");				//3  DRM_AD_STEREO		
	DataAudioTypes.Add("Dynamic labels");		//4  DRM_AD_DYNLABELS	
	DataAudioTypes.Add("MOT Slideshow");		//5  DRM_AD_MOT_SLD		
	DataAudioTypes.Add("MOT WebSite");			//6  DRM_AD_MOT_WEB	
	DataAudioTypes.Add("TPEG");					//7  DRM_AD_TPEG		
	DataAudioTypes.Add("DGPS");					//8  DRM_AD_DGPS		differencial GPS
	DataAudioTypes.Add("TMC");					//9  DRM_AD_TMC		
	DataAudioTypes.Add("EPG");					//10 DRM_AD_EPG			electronic programm guide
	DataAudioTypes.Add("Java");					//11 DRM_AD_JAVA		
	DataAudioTypes.Add("Journaline");			//12 DRM_AD_JORNALINE	
	DataAudioTypes.Add("MOT Images");			//13 DRM_AD_MOT_IMG	
	DataAudioTypes.Add("MOT Wave");				//14 DRM_AD_MOT_WAVE	
	DataAudioTypes.Add("MOT Data");				//15 DRM_AD_MOT_DATA	
												
	CodecTypes.Add("Data");						//0  DRM_AC_DATA
	CodecTypes.Add("AAC");						//1  DRM_AC_AAC
	CodecTypes.Add("CELP");						//2  DRM_AC_CELP
	CodecTypes.Add("HVXC");						//3  DRM_AC_HVXC
	CodecTypes.Add("data");						//4  DRM_AC_DATA|DRM_AC_SMALL_RATE
	CodecTypes.Add("aac");						//5  DRM_AC_AAC |DRM_AC_SMALL_RATE
	CodecTypes.Add("celp");						//6  DRM_AC_CELP|DRM_AC_SMALL_RATE
	CodecTypes.Add("hvxc");						//7  DRM_AC_HVXC|DRM_AC_SMALL_RATE
	CodecTypes.Add("Data+");					//8  DRM_AC_DATA|DRM_AC_SBR_FLAG
	CodecTypes.Add("AAC+");						//9  DRM_AC_AAC |DRM_AC_SBR_FLAG
	CodecTypes.Add("CELP+");					//10 DRM_AC_CELP|DRM_AC_SBR_FLAG
	CodecTypes.Add("HVXC+");					//11 DRM_AC_HVXC|DRM_AC_SBR_FLAG
	CodecTypes.Add("data+");					//12 DRM_AC_DATA|DRM_AC_SMALL_RATE|DRM_AC_SBR_FLAG
	CodecTypes.Add("aac+");						//13 DRM_AC_AAC |DRM_AC_SMALL_RATE|DRM_AC_SBR_FLAG
	CodecTypes.Add("celp+");					//14 DRM_AC_CELP|DRM_AC_SMALL_RATE|DRM_AC_SBR_FLAG
	CodecTypes.Add("hvxc+");					//15 DRM_AC_HVXC|DRM_AC_SMALL_RATE|DRM_AC_SBR_FLAG

	LoadRegions();

	Get_LNG();
	Get_ADM();
	Get_AOKI_BIB();
}


void WINAPI	MergeFrqList() 
{
	char	buf[256];
//	FILE	*fi;
	FILE	*fo;
	int		i,max=0;
	int		dNew=0;
	int		dOld=0;
	time_t	today=time(0);
	UINT	ID=(today&0xFFFF)<<16;
	FRQLISTDAT		myHeadDummy={0};
	CTime	tim(today);

	myHeadDummy.dh.FrqBase=12;		//Bonito ID FrqData0C
	myHeadDummy.db.FrqSetDate=today;
	myHeadDummy.db.FrqUserID=0x414F4B49;
	sprintf(myHeadDummy.db.Commentary,"FrqData0C %s AOKI Source List = www1.s2.starcat.ne.jp/ndxc/news.htm",tim.Format("%d.%b.%Y"));
	strcpy(myHeadDummy.db.name,"FrqData0C AOKI Source List");

	sprintf(buf,"%s\\Data\\FrqData0C.bin",myDIR);
	fo=fopen(buf,"wb");
	fwrite(&myHeadDummy,sizeof(FRQLISTDAT),1,fo); //write the old Header Dummy
	for(i=0; i<FrqData.GetSize(); i++)
		{
		if(i&1) ID+=3;
		else ID+=2;

		FrqData[i].dh.FrqBase=12;		//Bonito ID FrqData0C
		FrqData[i].dh.show=1;	
		FrqData[i].db.FrqSetDate=today;
		FrqData[i].db.FrqSetID=ID;
		FrqData[i].db.FrqUserID=0x414F4B49;
		fwrite(&FrqData[i],1,sizeof(FRQLISTDAT),fo);
		}
	fclose(fo);
}

BOOL WINAPI getRegString(HKEY key, char *KeyName, char *ValName, char *Default, char* DatBuf)
{
	HKEY	hKey;
	long	retCode;
	DWORD	dat_sodb=255,val_type=REG_SZ;

	DatBuf[0]=0;

	retCode=RegOpenKeyEx(key,KeyName,0,KEY_READ,&hKey);
	if(!retCode)
		{
		retCode=RegQueryValueEx(
							hKey,				// handle to key to query
							ValName,			// address of name of value to query
							NULL,				// reserved
							&val_type,			// address of buffer for value type
							(BYTE*)DatBuf,		// address of data buffer
							&dat_sodb			// address of data buffer size
							);
  		RegCloseKey (hKey); 
		}
	if(retCode && Default) strcpy(DatBuf,Default);
	return(retCode);
}

BOOL WINAPI getBothRegistry(char *ValName, char *Default, char* DatBuf)
{
	BOOL ret=getRegString(HKEY_CURRENT_USER,"Software\\Bonito\\RadioJet 1.0",ValName,Default,DatBuf);
	if(ret)	ret=getRegString(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Bonito RadioJet 1.0",ValName,Default,DatBuf);
	return ret;
}

void WINAPI GetRadioJetDirectory()
{
	char buf[256];
	buf[0]=0;

	_getcwd(myDIR,255);
	getBothRegistry("AccessDir",myDIR,myDIR);
}

#include "Wininet.h"

// Flags for InternetGetConnectedState and Ex
//#define INTERNET_CONNECTION_MODEM           0x01	Local system uses a modem to connect to the Internet
//#define INTERNET_CONNECTION_LAN             0x02	Local system uses a local area network to connect to the Internet.
//#define INTERNET_CONNECTION_PROXY           0x04	Local system uses a proxy server to connect to the Internet.
//#define INTERNET_CONNECTION_MODEM_BUSY      0x08  /* no longer used */
//#define INTERNET_RAS_INSTALLED              0x10	Local system has RAS installed.
#define INTERNET_CONNECTION_OFFLINE         0x20	//Local system is in offline mode.
//#define INTERNET_CONNECTION_CONFIGURED      0x40  Local system has a valid connection to the Internet,
   											     // but it might or might not be currently connected.

BOOL WINAPI GetInternetConnectedState()
{
	ULONG	lpdwFlags;
	if(!(InternetGetConnectedState(&lpdwFlags,NULL))) return FALSE; 
	if(!(lpdwFlags & INTERNET_CONNECTION_OFFLINE)) return FALSE;
 return TRUE;	
}

DWORD	my_Connect=0;
void WINAPI ConnectOn()
{
	if(my_Connect) return;
	if(!GetInternetConnectedState()) 
		{
		//InternetAutodial(INTERNET_AUTODIAL_FORCE_UNATTENDED,my_mainframe->m_hWnd);
		InternetAutodial(INTERNET_AUTODIAL_FORCE_UNATTENDED,((ULONG)my_mainframe->m_hWnd));
		my_Connect=1;
		}
}

void WINAPI ConnectOff()
{
}

void WINAPI CloseConnect()
{
	if(my_Connect)
		{
		InternetAutodialHangup(NULL);
		my_Connect=NULL;
		}
}

BOOL WINAPI WriteText(char *text)
{
	my_mainframe->m_errorText=text;
	my_mainframe->UpdateData(FALSE);
	my_mainframe->erStatus.RedrawWindow();
	return NULL;
}

char ErrorMessageBuffer[256]; 
void WINAPI	ErrorMessages(char *buf,int flag)
{	
	char	tmp[512];

	if(flag) sprintf(tmp,"%s\n",buf);
	else strcpy (tmp,buf);
	WriteText(tmp);

} 

void WINAPI MakeDir(char *filename) 
{
	int		i,x;
	char	dir[512];

	dir[0]=0;
	for(i=0,x=0; i<(int)strlen(filename); i++)
		{
		if(filename[i]!='\\') {dir[x++]=filename[i]; dir[x]=0;}
		else
			{
			_mkdir(dir);
			dir[x++]=filename[i]; dir[x]=0;
			}
		}
}
