#ifndef OWN_TEST_ROUTINES
#define OWN_TEST_ROUTINES

#pragma pack(push)
#pragma pack(1)

typedef struct	{
				int		SchFrameID;
				int		StationsNr;
				short	RegionNr;
				short	StationsCountryNr;
				short	StationsLon;
				short	StationsLat;		
				}SCH_PARA;	//Schedule parameter

typedef struct	{
				double	frq;
				char	name[32];
				int		decoder;
				int		modulation;
				char	call[16];
				int		country;
				int		stationtype;
				int		steps;
				int		IF;
				double	txfrq;
				BOOL	att;
				BOOL	agc;
				BOOL	nb;
				int		volume;
				int		squelch;
				double	startfrq;
				double	stopfrq;
				int		scansteps;
				BOOL	wave_onoff; 
				BOOL	line_onoff; 
				BOOL	dec_filter; 
				BOOL	antenna; 
				union
					{
					char		equ_filter_name[16];
					SCH_PARA	sch;
					};
				int		wave_out_vol;
				int		line_in_vol;
				int		line_out_vol; 
				int		audio_squelch;
				int		scanrec;
				int		scansqlstop;
				int		rectime;
				int		scanwhiletime;
				int		scanausq;
				BOOL	assume_radio; 
				BOOL	assume_audio; 
				int		flags;
				int		CW_center;
				int		CW_mark;
				int		CW_width;
				int		FAX_modul;
				int		FAX_speed;
				int		FAX_centerfrq;
				int		FAX_shift;
				int		FAX_filtermode;
				int		FAX_filterwidth;
				int		FAX_hmirror;
				int		FAX_vmirror;
				int		FAX_amfm;
				int		FAX_filteronoff;
				int		FAX_burst1;
				int		FAX_burst2;
				int		FAX_syncwidth;
				int		FAX_invertsync;
				int		RTTY_mode;
				int		RTTY_baud;
				int		RTTY_mark;
				int		RTTY_space;
				double	RTTY_stopbits;
				int		RTTY_polarity;

				union
					{
					int		SSTV_mode; 
					int		SSTV_vis; 
					};
				union
					{
					int		SSTV_filterlofrq;
					int		SSTV_synfrq;
					};
				union
					{
					int		SSTV_filterhifrq;
					int		SSTV_filterwidth;
					};
				union
					{
					int		SSTV_filterorder;
					int		SSTV_filtertype;
					};
				union
					{
					int		SSTV_manual_filtemode;
					int		SSTV_filter_onoff;
					};

				char	Commentary[80];
				int		modulationtype;
				int		SatID;
				int		TimerStartTime;
				int		TimerStopTime;
				union
					{
					int		Extension_3;
					char	NAVTEX_RegLetter;
					};
				int		equ_filter;		
				}O_FRQLISTSET;



typedef struct	{
				int		FrqSetID;
				int		FrqSetDate;
				BYTE	FrqSourceID;
				BYTE	SchSourceID;
				short	lastupdate;	
				union
					{
					int		SchFrameID;
					int		NavFrameID;
					int		WebFrameID;
					int		SatFrameID;
					};
				}O_FRQLISTHEAD;


typedef struct	{
				O_FRQLISTSET	db;
				O_FRQLISTHEAD	dh;
				char		res[512-sizeof(O_FRQLISTSET)-sizeof(O_FRQLISTHEAD)];
				}O_FRQLISTDAT;


typedef CArray<O_FRQLISTDAT,O_FRQLISTDAT&> OldFrqListData;





extern OldFrqListData	mOldData;



#pragma pack(pop)
#endif